Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QStackedWidget

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.gui.QWidget
                      com.trolltech.qt.gui.QFrame
                          com.trolltech.qt.gui.QStackedWidget

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

    public class QStackedWidget

extends QFrame

The `QStackedWidget` class provides a stack of widgets where only one widget is visible at a time.

`QStackedWidget` can be used to create a user interface similar to the one provided by `QTabWidget`. It is a convenience layout widget built on top of the `QStackedLayout` class.

Like `QStackedLayout`, `QStackedWidget` can be constructed and populated with a number of child widgets ("pages"):

            QWidget *firstPageWidget = new QWidget;
            QWidget *secondPageWidget = new QWidget;
            QWidget *thirdPageWidget = new QWidget;

            QStackedWidget *stackedWidget = new QStackedWidget;
            stackedWidget->addWidget(firstPageWidget);
            stackedWidget->addWidget(secondPageWidget);
            stackedWidget->addWidget(thirdPageWidget);

            QVBoxLayout *layout = new QVBoxLayout;
            layout->addWidget(stackedWidget);
            setLayout(layout);

`QStackedWidget` provides no intrinsic means for the user to switch page. This is typically done through a `QComboBox` or a `QListWidget` that stores the titles of the `QStackedWidget`'s pages. For example:

            QComboBox *pageComboBox = new QComboBox;
            pageComboBox->addItem(tr("Page 1"));
            pageComboBox->addItem(tr("Page 2"));
            pageComboBox->addItem(tr("Page 3"));
            connect(pageComboBox, SIGNAL(activated(int)),
                    stackedWidget, SLOT(setCurrentIndex(int)));

When populating a stacked widget, the widgets are added to an internal list. The `indexOf` function returns the index of a widget in that list. The widgets can either be added to the end of the list using the `addWidget` function, or inserted at a given index using the `insertWidget` function. The `removeWidget` function removes the widget at the given index from the stacked widget. The number of widgets contained in the stacked widget, can be obtained using the `count` function.

The `widget` function returns the widget at a given index position. The index of the widget that is shown on screen is given by `currentIndex` and can be changed using `setCurrentIndex`. In a similar manner, the currently shown widget can be retrieved using the `currentWidget` function, and altered using the `setCurrentWidget` function.

Whenever the current widget in the stacked widget changes or a widget is removed from the stacked widget, the `currentChanged` and `widgetRemoved` signals are emitted respectively.

See Also:
  `QStackedLayout`, `QTabWidget`, Config Dialog Example

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QFrame
`QFrame.Shadow, QFrame.Shape, QFrame.StyleMask`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Field Summary
`QSignalEmitter.Signal1<java.lang.Integer>` | `currentChanged` This signal is emitted whenever the current widget changes.
`QSignalEmitter.Signal1<java.lang.Integer>` | `widgetRemoved` This signal is emitted whenever a widget is removed.

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Constructor Summary
`QStackedWidget()` Equivalent to `QStackedWidget`(0).
`QStackedWidget(QWidget parent)` Constructs a `QStackedWidget` with the given `parent`.

Method Summary
`int` | `addWidget(QWidget w)` Appends the given `w` to this `QStackedWidget` and returns the index position.
`int` | `count()` Returns the number of widgets contained by this stacked widget.
`int` | `currentIndex()` Returns the index position of the widget that is visible.
`QWidget` | `currentWidget()` Returns the current widget, or 0 if there are no child widgets.
`boolean` | `event(QEvent e)` This function is reimplemented for internal reasons.
`static QStackedWidget` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QStackedWidget instance pointed to by nativePointer
`int` | `indexOf(QWidget arg__1)` Returns the index of the given `arg__1`, or -1 if the given `arg__1` is not a child of this `QStackedWidget`.
`int` | `insertWidget(int index, QWidget w)` Inserts the given `w` at the given `index` in this `QStackedWidget`.
`void` | `removeWidget(QWidget w)` Removes the given `w` from this `QStackedWidget`.
`void` | `setCurrentIndex(int index)` Sets the index position of the widget that is visible to `index`.
`void` | `setCurrentWidget(QWidget w)` Sets the current widget to be the specified `w`.
`QWidget` | `widget(int arg__1)` Returns the widget at the given `arg__1`, or 0 if there is no such widget.

Methods inherited from class com.trolltech.qt.gui.QFrame
`changeEvent, drawFrame, frameRect, frameShadow, frameShape, frameStyle, frameWidth, lineWidth, midLineWidth, paintEvent, setFrameRect, setFrameShadow, setFrameShape, setFrameStyle, setLineWidth, setMidLineWidth, sizeHint`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, createWinId, cursor, depth, destroy, destroy, destroy, devType, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isLeftToRight, isMaximized, isMinimized, isModal, isRightToLeft, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, overrideWindowState, overrideWindowState, paintEngine, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`blockSignals, childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, property, removeEventFilter, setObjectName, setParent, setProperty, signalsBlocked, startTimer, thread, timerEvent`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`disconnect, disconnect, signalSender`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### currentChanged

    public final QSignalEmitter.Signal1<java.lang.Integer> currentChanged

  This signal is emitted whenever the current widget changes.

  The parameter holds the `arg__1` of the new current widget, or -1 if there isn't a new one (for example, if there are no widgets in the `QStackedWidget`).

  Compatible Slot Signatures:
    `void mySlot(int arg__1)`
    `void mySlot()`
  See Also:
    `currentWidget`, `setCurrentWidget`

### widgetRemoved

    public final QSignalEmitter.Signal1<java.lang.Integer> widgetRemoved

  This signal is emitted whenever a widget is removed. The widget's `index` is passed as parameter.

  Compatible Slot Signatures:
    `void mySlot(int index)`
    `void mySlot()`
  See Also:
    `removeWidget`

Constructor Detail

### QStackedWidget

    public QStackedWidget()

  Equivalent to `QStackedWidget`(0).

### QStackedWidget

    public QStackedWidget(QWidget parent)

  Constructs a `QStackedWidget` with the given `parent`.

  See Also:
    `addWidget`, `insertWidget`

Method Detail

### addWidget

    public final int addWidget(QWidget w)

  Appends the given `w` to this `QStackedWidget` and returns the index position.

  If the `QStackedWidget` is empty before this function is called, `w` becomes the current widget.

  See Also:
    `insertWidget`, `removeWidget`, `setCurrentWidget`

### count

    public final int count()

  Returns the number of widgets contained by this stacked widget.

  See Also:
    `currentIndex`, `widget`

### currentIndex

    public final int currentIndex()

  Returns the index position of the widget that is visible.

  The current index is -1 if there is no current widget.

  See Also:
    `setCurrentIndex`, `currentWidget`, `indexOf`

### currentWidget

    public final QWidget currentWidget()

  Returns the current widget, or 0 if there are no child widgets.

  See Also:
    `currentIndex`, `setCurrentWidget`

### indexOf

    public final int indexOf(QWidget arg__1)

  Returns the index of the given `arg__1`, or -1 if the given `arg__1` is not a child of this `QStackedWidget`.

  See Also:
    `currentIndex`, `widget`

### insertWidget

    public final int insertWidget(int index,
                                  QWidget w)

  Inserts the given `w` at the given `index` in this `QStackedWidget`. If `index` is out of range, the `w` is appended (in which case it is the actual index of the `w` that is returned).

  If the `QStackedWidget` was empty before this function is called, the given `w` becomes the current widget.

  Inserting a new widget at an index less than or equal to the current index will increment the current index, but keep the current widget.

  See Also:
    `addWidget`, `removeWidget`, `setCurrentWidget`

### removeWidget

    public final void removeWidget(QWidget w)

  Removes the given `w` from this `QStackedWidget`. The widget is not deleted.

  See Also:
    `addWidget`, `insertWidget`, `currentWidget`

### setCurrentIndex

    public final void setCurrentIndex(int index)

  Sets the index position of the widget that is visible to `index`.

  The current index is -1 if there is no current widget.

  See Also:
    `currentIndex`, `currentWidget`, `indexOf`

### setCurrentWidget

    public final void setCurrentWidget(QWidget w)

  Sets the current widget to be the specified `w`. The new current widget must already be contained in this stacked widget.

  See Also:
    `currentWidget`, `setCurrentIndex`

### widget

    public final QWidget widget(int arg__1)

  Returns the widget at the given `arg__1`, or 0 if there is no such widget.

  See Also:
    `currentWidget`, `indexOf`

### event

    public boolean event(QEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `event` in class `QFrame`
  See Also:
    `closeEvent`, `focusInEvent`, `focusOutEvent`, `enterEvent`, `keyPressEvent`, `keyReleaseEvent`, `leaveEvent`, `mouseDoubleClickEvent`, `mouseMoveEvent`, `mousePressEvent`, `mouseReleaseEvent`, `moveEvent`, `paintEvent`, `resizeEvent`, `QObject::event`, `QObject::timerEvent`

### fromNativePointer

    public static QStackedWidget fromNativePointer(QNativePointer nativePointer)

  This function returns the QStackedWidget instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD